/*
    Init Task
    任务初始化，创建各个线程任务和消息队列
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"

/* USER INCLUDE BEGIN */
#include "module/cmd.h"
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */

/**
 * \brief 初始化
 *
 * \param argument 未使用
 */
void Task_Init(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */
    /* USER CODE INIT BEGIN */

    /* USER CODE INIT END */
  osKernelLock(); /* 锁定内核，防止任务切换 */
  
  /* 创建任务线程 */
  task_runtime.thread.atti_esti = osThreadNew(Task_atti_esti, NULL, &attr_atti_esti);
  task_runtime.thread.rc = osThreadNew(Task_rc, NULL, &attr_rc);
  task_runtime.thread.chassis_task = osThreadNew(Task_chassis_task, NULL, &attr_chassis_task);
  task_runtime.thread.cmd_task = osThreadNew(Task_cmd_task, NULL, &attr_cmd_task);
  task_runtime.thread.rc_up = osThreadNew(Task_rc_up, NULL, &attr_rc_up);
  task_runtime.thread.test = osThreadNew(Task_test, NULL, &attr_test);

  // 创建消息队列
  /* USER MESSAGE BEGIN */
  task_runtime.msgq.user_msg= osMessageQueueNew(2u, 10, NULL);
  task_runtime.msgq.cmd.rc= osMessageQueueNew(2u, sizeof(CMD_RC_t), NULL);
  task_runtime.msgq.assmble.assmble_cmd= osMessageQueueNew(2u, sizeof(Assemble_CMD_t), NULL);
  task_runtime.msgq.chassis.cmd= osMessageQueueNew(2u, sizeof(Chassis_CMD_t), NULL);
  /* USER MESSAGE END */

  osKernelUnlock(); // 解锁内核
  osThreadTerminate(osThreadGetId()); // 任务完成后结束自身
}